; Reduction programs.  Uses definitions in graph.lisp.

; Functions in reducb.lisp:

(proclaim '(type function fxCHK fxOR fx5NW two-arguments))

(*defun setype (ty p)
"(setype ty p) -- set ty to type of (G!! p)"
 (declare (type (field-pvar TY-SZ) ty))
 (declare (type (field-pvar CA-SZ) p))
 (*cond ((<=!! p (!! syscmx)) (*set ty (!! (ty-sysc))))
	((<!!  p (!! ATML))   (*set ty (!! (ty-dict))))
	(T!!                  (*set ty (G!! p))))
)

(*defun setypem (ty p)
"(setypem ty p) -- set ty to type of (G!! p) - many collisions"
 (declare (type (field-pvar TY-SZ) ty))
 (declare (type (field-pvar CA-SZ) p))
 (*cond ((<=!! p (!! syscmx)) (*set ty (!! (ty-sysc))))
	((<!!  p (!! ATML))   (*set ty (!! (ty-dict))))
	(T!! (*set ty (pref!! GTYP p :many-collisions))))
)

(*defun forwardx (pr px b)
"(forwardx pr px b) -- forward pr to px testing type bit b"
 (declare (type (field-pvar CA-SZ) pr px))
 (declare (type fixnum b))
 (*when (and!! (bit!! GTYX b) (activep px)) (+F!! px 1))
 (*when (and!! (bit!! GTYP b) (activep pr)) (+F!! pr -1))
 (*set pr px)
)

(*defun frwrd (p n)
"(frwrd p n) -- forward p to point to n"
 (declare (type (field-pvar CA-SZ) p n))
 (*when* (activep n) (+F!! n 1))
 (*when* (activep p) (+F!! p -1))
 (*set p n)
)

(*defun forward (p)
"(forward p) -- forward p in css (all valid), adjusting refc"
 (declare (type (field-pvar CA-SZ) p))
 (*when* (and!! (>!! p (!! syscmx)) (V!! p)) (*set A (RX!! p))  (frwrd p A))
)

(*defun qforward (p)
"(qforward p) -- forward p in css (all valid), adjusting qntc"
 (declare (type (field-pvar CA-SZ) p))
 (*when* (and!! (>!! p (!! syscmx)) (V!! p))
   (*set A (RX!! p))
   (+Q!! A 1)  (+Q!! p -1)  (*set p A))
)

; Macros to keep FIRE readable:
; (format ...) calls which are in comments may be used to track errors:

(defmacro advance ()
"(advance) -- Advance pointers after ult!!"
  '(progn
     (*when (not!! NRMT)   ; Forward remaining pointers
       (*when (and!! (VLP!!) (not!! NMLT) (not!! (and!! STRT (COMBP!!))))
              (forward LPTR))             ; (format t "Forwarded L...~%")
       (*when (and!! (not!! VIST) (VRP!!) (not!! NMRT)) (forward RPTR))
                                          ; (format t "Forwarded R...~%")
       (*when (VCP!!) (qforward CXTP)))   ; (format T "Forwarded C...~%")
     (*when (and!! (COMBP!!) (/=!! CXTP (self-address!!)) (V!! CXTP))
	    (sC!! (RX!! CXTP)))           ; (format t "Update C...~%")
    )
)

(defmacro update-str ()
"(update-str) -- update STRT"
            '(*when (if!! (<=!! LPTR (!! syscmx))
		       (<=!! (!! CB-[]) LPTR (!! CB-inf))
		       (or!! (<!! LPTR (!! ATML))
		             (pref!! STRT LPTR :many-collisions)))
		    (sSTX!! T!!))
)

(defmacro update-graph ()
"(update-graph) -- updates graph and records statistics"
'(progn
 (*when (<!! RDTN (!! 255)) (setq REDUCTIONS (*sum (!! 1)))
        (when *STATS* (gatherstats))
        (*when (plusp!! RDTN) (sNL!! nil!!) (sNR!! nil!!)
	       (forwardx LPTR LPTX 7) (forwardx RPTR RPTX 6))
	(*when* (or!! (=!! RDTN (!! 132))
		      (and!! (=!! RDTN (!! 254)) (=!! GTYX (!! (ty-var)))))
		(+Q!! CXTX 1))
	(*when* (<=!! (!! 131) RDTN (!! 132)) (+Q!! CXTP -1))
    ) ; end *when for update
 (sG!! GTYX)  (sC!! CXTX) (incf TOTRDTNS REDUCTIONS) (incf FIRINGS)
 ) ; end progn
)

(defun FIRE ()
"(FIRE) -- performs one cycle of parallel reduction"
 (if (eq SYS-mode 'BUILDING) (make-running))
 (*set NX (!! 0))  (sRN!! (!! 255))  (sGX!! GTYP) (setq REDERROR nil)
 (garbage)
 (*when (and!! (/=!! GTYP (!! (ty-free))) (/=!! GTYP (!! (ty-dummy)))
	       (/=!! GTYP (!! (ty-notn))) (/=!! GTYP (!! (ty-dead))))
     (ult!!)                              ; (format t "Past ult!!...~%")
     (advance)
     (sLX!! LPTR)  (*when (not!! VIST) (sRX!! RPTR))  (sCX!! CXTP)
     (sSTX!! STRT)  (sV!! nil!!)  (*set B RPTR)  (*set QNTT (plusp!! QNTC))
     (*cond ((or!! NRMT (VARP!!) (POINTP!!)))
	    ((or!! STRT (not!! (COMBP!!)))
	     (sS!! T!!) (sSTX!! T!!) (*set NX (cNM!!)))
	    (IRRT (*set NX (cNM!!)))
	    (T!!                           ; (format t "Combinations...~%")
             (update-str)
	     (setypem LTY LPTR)  (setype BTY B)
	     (*if (/=!! LTY (!! (ty-comb)))
	       (one-argument)
	       (progn (*set LL (L!! LPTR)) (setype LLTY LL)
		      (*set A (R!! LPTR))  (*set LQNT (QNT!! LPTR))
		      (*if (=!! LLTY (!! (ty-sysc)))
			(progn (setype ATY A) (two-arguments))
			(three-arguments))))))
     (*when* (tPNT!!) (fxPNT))
     (*when* (tCHK!!) (fxCHK))
     (*when* (tCXT!!) (fxCXT))
     (*when* (tSPL!!) (fxSPL))
     (*when* (t5NW!!) (fx5NW))
     (*when  (tNM!!)  (fxNM))           ; (format t "Finished reductions...~%")
     (sS!! STXT)     ; Update structure flags (copies don't participate)
   ) ; end *when for active nodes
 (update-graph)                         ; (format t "Updated all...~%")
 ; (*when* (and!! (COMBP!!) (zerop!! RPTR)) (setq REDERROR 'ZERO-POINTER))
)  ; end fire

(defun make-running ()
"(make-running) -- changes to running mode, except for garbage collection"
 (*when* (and!! (bit!! GTYP 7) (<!! (!! syscmx) LPTR (!! ATML))
	        (=!! (pref!! GTYP LPTR :many-collisions) (!! (ty-notn))))
	 (frwrd LPTR (R!! LPTR)))
 (*when* (and!! (bit!! GTYP 6) (<!! (!! syscmx) RPTR (!! ATML))
	        (=!! (pref!! GTYP RPTR :many-collisions) (!! (ty-notn))))
	 (frwrd RPTR (R!! RPTR)))
 (*when* (and!! (bit!! GTYP 5) (<!! (!! syscmx) CXTP (!! ATML))
	        (=!! (pref!! GTYP LPTR :many-collisions) (!! (ty-notn))))
	 (sC!! (R!! CXTP)))
 (*when* (and!! (NOTNP!!) (plusp!! QNTC))
	 (sim*pset QNTC RPTR)  (sQ!! (!! 0)))
 (setq SYS-mode 'RUNNING)
)

(defun gatherstats ()
"(gatherstats) -- tallys reductions in current firing"
 (*let (dx) (declare (type (field-pvar CA-SZ) dx))
   (*all (*set dx (!! 0)))
   (*pset :add (!! 1) dx RDTN)
   (*all (*set STATS (+!! STATS dx)))
 )
)

; Argument is B, with type BTY

(defun one-argument ()
"(one-argument) -- handles one-argument applications"
 (*cond* ((=!! LTY (!! (ty-cons)))
	  (*if (QNT!! LPTR)  (sSTX!! nil!!)
	    (when (2newc!! (ty-comb) (ty-comb))
	     (*psetno (L!! LPTR) LPTX D) (*psetno B RPTX D)
	     (*psetno (R!! LPTR) LPTX E) (*psetno B RPTX E)
	     (sLX!! D) (sRX!! E) (sGX!! (!! (ty-cons)))  (sRN!! (!! 130)))))
	 ((=!! LTY (!! (ty-sysc))) (one-logical))
	 (T!! (*set NX (cNM!!))))
)

(defun one-logical ()
"(one-logical) -- handles one-arg forms with sysc as opr"
 (sRN!! (load-byte!! LPTR (!! 0) (!! TY-SZ)))
 (*cond* ((=!! RDTN (!! CB-I))  (sGX!! (!! (ty-point)))  (sRX!! RPTR))
         ((=!! RDTN (!! CB-Y))
            (sGX!! (!! (ty-comb)))  (sLX!! RPTR)  (sRX!! (self-address!!)))
	 ((progn (*set ATY (logxor!! RDTN (!! CB-and)))
		 (<=!! ATY (!! maxbool)))                 ; Boolean op
	  (*if (true-false B)
	       (progn
		 (*set ATY (logior!! (ash!! ATY (!! 1))
                                     (load-byte!! B (!! 0) (!! 1))))
		 (sRX!! (load-byte!! AND-IF (ash!! ATY (!! 2)) (!! 4)))
		 (*set NX (cPNT!!)))
	       (*set NX (cNM!!))))
	 ((<=!! (logxor!! RDTN (!! CB-head)) (!! 1))   ; head or tail
	  (*if (=!! BTY (!! (ty-cons)))
	    (*if (QNT!! B) (sRN!! (!! 255))
	     (progn (*set NX (cPNT!!))
	       (*if (oddp!! RDTN) (*set RPTX (R!! B)) (*set RPTX (L!! B)))))
	     (*set NX (cNM!!))))
         ((=!! RDTN (!! CB-pair))
            (*if (=!! BTY (!! (ty-cons)))
		 (sRX!! (!! CB-true)) (sRX!! (!! CB-false)))
            (*set NX (cPNT!!)))
         ((or!! (=!! RDTN (!! CB-true)) (=!! RDTN (!! CB-FALSE))
                (=!! RDTN (!! CB-[])))
            (sRX!! LPTR) (*set NX (cPNT!!)))
         (T!! (*set IRRT T!!) (*set NX (cNM!!)) (sRN!! (!! 255)))
 )
)

; Args A and B, LLL unknown, LL has type LLTY, not sysc

(defun three-arguments ()
"(three-arguments) -- handles three-argument applications"
 (*set NX (cNM!!))
 (*when (=!! LLTY (!! (ty-comb)))
   (*set LLL (L!! LL))
   (*when (and!! (<=!! LLL (!! CB-C)) (bit!! LLL 2))
     (*set NX (!! 0))
     (*when (and!! (not!! LQNT) (not!! (QNT!! LL)))
	(*set F (R!! LL))
	(sRN!! (load-byte!! LLL (!! 0) (!! TY-SZ)))
	(*if* (=!! RDTN (!! CB-S))
	      (if (2newc!! (ty-comb) (ty-comb))
		  (progn (sLX!! D)  (sRX!! E)
			 (*psetno F LPTX D)  (*psetno B RPTX D)
			 (*psetno A LPTX E)  (*psetno B RPTX E))
		  (sRN!! (!! 255)))
	      (if (newc!! (ty-comb))
		  (progn (*psetno B RPTX D)
		       (*if (=!! RDTN (!! CB-C))
		         (progn (*psetno F LPTX D)  (sLX!! D)  (sRX!! A))
		         (progn (*psetno A LPTX D)  (sLX!! F)  (sRX!! D))))
		  (sRN!! (!! 255)))
       ) ; end *if*
     ))) ; end *when
)	 

(defun fxPNT ()
"Make node a pointer to P"
(sGX!! (!! (ty-point)))
)

; fxCHK is implemented in reducb.lisp, it's not used as a "go to" function.
; fxOR  is implemented in reducb.lisp, it's not used as a "go to" function.

(defun fxCXT ()
"Propagate context information in AND combinations"
 (*when* (or!! PCXT (plusp!! QNTC))
   (*set PCXT nil!!)
   (*when (and!! (=!! ATY (!! (ty-comb))) (zerop!! (Q!! A)))
	  (*pset :no-collisions CXTP CXTX A PCXT))
   (*when (and!! (=!! BTY (!! (ty-comb))) (zerop!! (Q!! B)))
	  (*pset :no-collisions CXTP CXTX B PCXT)))
)

(defun fxSPL ()
"Unify compatible, structural morphs"
 (*if (or!! (QNT!! A) (QNT!! B))
   (sRN!! (!! 255))
   (if (5newc!! CB-and CB-=)
     (progn (*psetno (L!! B) RPTX D)
	    (*psetno (L!! A) RPTX E)
	    (*psetno (R!! B) RPTX F)
	    (*psetno (R!! A) RPTX G)
	    (*set LPTX C)  (*set RPTX F))
     (progn (*set NX (cNM!!)) (sRN!! (!! 255))))
  ) ; end *if
)

(defun fxNM ()
"Check combination or cons for normal form"
 (*when (and!! (bit!! GTYP 7) (bit!! GTYP 6))
	 (*if (or!! NMLT (<!! LPTR (!! ATML))
		    (=!! LPTR (self-address!!)) (N!! LPTR)) (sNL!! T!!))
	 (*if (or!! NMRT (<!! RPTR (!! ATML))
		    (=!! RPTR (self-address!!)) (N!! RPTR)) (sNR!! T!!)))
 (*if (and!! NMLT NMRT) (sN!! T!!))
)

(*defun is-IND!! (n)
"(is-IND!! n) -- n is a pointer"
 (and!! (>=!! n (!! ATML)) (=!! (G!! n) (!! (ty-point))))
)

(defun ult!! ()
"(ult!!) -- forwards pointers to ultimate values, leaving these in
            RX and V=T in all cases, sets GX, RN where changed."
 (*when* (POINTP!!)
   (sRX!! RPTR)
   (*if (not!! (is-IND!! RPTR)) (sV!! T!!)
    (live (sGX!! GTYP)  (sRN!! (!! 129))  (sV!! nil!!)
     (with-css-saved (prog ()
       ; RX is indirect, V = nil in CSS, which is not empty
      A  (*cond ((=!! RPTX (self-address!!))
		 (*set REFC (1-!! REFC))  (sV!! T!!))
		((V!! RPTX) (sV!! T!!) (sRX!! (RX!! RPTX)))
		(T!! (sRX!! (R!! RPTX))
		     (*when (not!! (is-ind!! RPTX)) (sV!! T!!))))
         (*when* (not!! VIST) (go A))
     )) ; end with-css-saved
     (sV!! T!!)
    )))
)


; Parallel allocation.  New nodes have G = new, GX = gx.

(defun newc!! (gx)
"(newc!! gx) -- Allocates new procs for CSS, returns T if successful,
            leaves pointer in  D.  Returns NIL with no effect otherwise."
 (let ((na (*sum (!! 1))) (cf CFREE))
   (when (> na CFREE) (return-from newc!! nil))
   (setq CFREE (- CFREE na))
   (*set D (+!! (enumerate!!) (!! (- MXCA na))))
   (*all (*when (and!! (FREEP!!) (>=!! REFC  (!! CFREE)))
       (sG!! (!! (ty-new)))  (sGX!! (!! gx))  (sRN!! (!! 254))
       (sC!! (self-address!!)) (sCX!! CXTP)
       (*pset :default (self-address!!) RV (+!! REFC (!! (- MXCA cf))))
       (sF!! (!! 0))
    )) ; end *all
   (*set D (RV!! D))
   T)
)

(defun 2newc!! (gx gy)
"(2newc!! gx gy) -- Allocates 2 new procs for CSS, returns T if successful,
            leaves pointers in  D, E.  Returns NIL with no effect otherwise."
 (let ((na (*sum (!! 1))) (cf CFREE) nx ga gb)
   (setq nx (ash na 1))
   (when (> nx CFREE) (return-from 2newc!! nil))
   (setq CFREE (- CFREE nx))
   (*set D (+!! (ash!! (enumerate!!) (!! 1)) (!! (- MXCA nx))))
   (*set E (1+!! D))
   (*all (*when (and!! (FREEP!!) (>=!! REFC  (!! CFREE)))
       (sG!! (!! (ty-new)))  (sRN!! (!! 254))
       (if (oddp CFREE) (progn (setq ga gx) (setq gb gy))
                        (progn (setq ga gy) (setq gb gx)))
       (*if (bit!! REFC 0) (sGX!! (!! ga)) (sGX!! (!! gb)))
       (sC!! (self-address!!)) (sCX!! CXTP)
       (*psetno (self-address!!) RV (+!! REFC (!! (- MXCA cf))))
       (sF!! (!! 0))
    ))
   (*set D (RV!! D))  (*set E (RV!! E))
   T)
)

; All new procs get type ty-comb, fills in operator addresses

(defun 5newc!! (opa opb)
"(5newc!! opa opb) -- Allocates 5 new procs for CSS, returns T if successful,
            leaves pointers in  C - G.  Returns NIL with no effect otherwise."
 (let ((na (*sum (!! 1))) (cf CFREE) nk)
   (setq nk (* 5 na))
   (when (> nk CFREE) (return-from 5newc!! nil))
   (setq CFREE (- CFREE nk))
   (*set C (+!! (*!! (enumerate!!) (!! 5)) (!! (- MXCA nk))))
   (*set D (1+!! C))  (*set E (1+!! D))  (*set F (1+!! E))  (*set G (1+!! F))
   (*all (*when (and!! (FREEP!!) (>=!! REFC  (!! CFREE)))
       (sG!! (!! (ty-new)))  (sRN!! (!! 254))
       (sGX!! (!! (ty-comb)))
       (sC!! (self-address!!)) (sCX!! CXTP)
       (*psetno CXTP RV (+!! REFC (!! (- MXCA cf))))
       (*set A (mod!! (-!! REFC (!! CFREE)) (!! 5)))
       (*if (zerop!! A) (sLX!! (!! opa))
            (*if (evenp!! A) (sLX!! (!! opb))))
       (sF!! (!! 0))
    ))
   (*set C (RV!! C))  (*set D (RV!! D))  (*set E (RV!! E))
   (*set F (RV!! F))  (*set G (RV!! G))  (*set NX (c5NW!!))  T)
)


(defmacro ST (i) `(pref STATS ,i))

(defun statreport ()
"(statreport) -- reports current reduction statistics by type"
(let (ops)
 (*when (<!! (!! 0) (self-address!!) (!! 128)) (setq ops (*sum STATS)))
 (format t "~%Total reductions ~D  Total operations ~D  Total firings ~D~%"
                       TOTRDTNS          ops                FIRINGS)
 (format t "Garbg ~7D | New   ~7D |~%" (ST 0) (ST 254))
 (format t "Dead  ~7D | Orvar ~7D | Frwrd ~7D | Cons  ~7D | Bind  ~7D~%"
               (ST 253)    (ST 132)    (ST 129)    (ST 130)    (ST 131))
 (let ((k 0))
   (*when (SYSCP!!)
      (do-for-selected-processors (i)
	 (format t "~5A ~7D" (aref symvec (X i)) (ST i))
	 (if (= (incf k) 5)
	     (progn (setq k 0) (terpri)) (format t " | ")))))
 (values))
)
